#include "DebugHeader.H"
#include "EnemyObj.H"
#include "PlayerInfo.H"
#include "GlobalDataBase.H"

/* 
   Copyright 2007 Man Hon Chan, Zhangbo Liu, Simon Suyadi
   This code is Licensed under GPL.
 */

DEF_FERR("EnemyObj");

void EnemyObj::Init(GameObj* game_obj) {
  GameObjWrapper::Init(game_obj);
  id = GlobalDataBase::GetPlayerInfo().get_id(game_obj);
}

void EnemyTank::Init(GameObj* game_obj) {
  EnemyObj::Init(game_obj);
  cluster = NULL;
  hp = *gameObj->get_int_ptr("hp"); // id doesn't have to be updated
}

bool EnemyObj::Update() {
  if (!GameObjWrapper::Update()) return false;
  hp = *gameObj->get_int_ptr("hp"); // id doesn't have to be updated
  return true;
}

void EnemyCC::Init(GameObj* game_obj) {
  EnemyObj::Init(game_obj);
  leftTop = WorldCoor(*game_obj->sod.x1, *game_obj->sod.y1);
  rightBottom = WorldCoor(*game_obj->sod.x2, *game_obj->sod.y2);
  worldCoor = WorldCoor((leftTop.x + rightBottom.x) / 2,
      (leftTop.y + rightBottom.y) / 2 );
  mapCoor = MapBox::GetMapCoor(worldCoor);
  hp = *gameObj->get_int_ptr("hp"); // id doesn't have to be updated
}

bool EnemyCC::Update() {
  // I have to check if I am dead
  if (! (dead = gameObj->is_dead() || (!gameObj->sod.in_game) ) )
    hp = *gameObj->get_int_ptr("hp");
  return !dead;
}

