#ifndef ENEMY_OBJ_H
#define ENEMY_OBJ_H

#include "ScriptObj.H"
#include "GameObjWrapper.H"

class Cluster;

class EnemyObj : public GameObjWrapper {
  public:
    bool Update();
    inline const sint4& GetHP() const { return hp; }
    inline const ObjId& GetID() const { return id; }
    int enemyIndex; // Used by GlobalDataBase to keep track of ALL enemies
  protected:
    sint4 hp;
    ObjId id;
    EnemyObj() {}
    void Init(GameObj* game_obj);
};

class EnemyTank: public EnemyObj { // Nothing too special about this
  public:
    EnemyTank():EnemyObj() {}
    void Init(GameObj* game_obj);
    inline void SetCluster(Cluster* cluster_) { cluster = cluster_; }
    inline Cluster* GetCluster() { return cluster; }
  protected:
  private:
    Cluster* cluster;
};

class EnemyCC: public EnemyObj {
  public:
    EnemyCC():EnemyObj() {}
    inline const WorldCoor& GetLeftTop() const { return leftTop; }
    inline const WorldCoor& GetRightBottom() const { return rightBottom; }
    inline const MapCoor GetTargetPoint(const WorldCoor& from) const {
      MapCoor ret(mapCoor);
      //if (from.x > worldCoor.x) ret.c -= 2;
      //else if (from.x < worldCoor.x) ret.c += 2;
      //if (from.y > worldCoor.y) ret.r -= 2;
      //else if (from.y < worldCoor.y) ret.r += 2;
      if (from.x > worldCoor.x) ret.c -= 2;
      else ret.c +=2;
      return ret;
    }
    void Init(GameObj* game_obj);
    bool Update();
  private:
    WorldCoor leftTop, rightBottom;
};

#endif
