#include "DebugHeader.H"
#include "GameObjWrapper.H"
#include "FFData.H"

/* 
   Copyright 2007 Man Hon Chan, Zhangbo Liu, Simon Suyadi
   This code is Licensed under GPL.
 */

DEF_FERR("GameObjWrapper");

namespace {
  template<typename T>
    class HashFunc_Pointer {
      public:
        inline size_t operator() (const T* const &x) const {
          return (size_t) x;
        }
    };

  EXT_NAMESPACE::hash_map<GameObj*, GameObjWrapper*, HashFunc_Pointer<GameObj> > gameObjMap;
}

void GameObjWrapper::Init(GameObj* game_obj) {
  gameObj = game_obj;
  gameObjMap[gameObj] = this;
  Update();
}

GameObjWrapper::~GameObjWrapper() {
  gameObjMap.erase(gameObj);
}

GameObjWrapper* GameObjWrapper::GetWrapper(GameObj* game_obj) {
  typeof(gameObjMap.begin()) it = gameObjMap.find(game_obj);
  if (it != gameObjMap.end()) return it->second;

  LOG(ferr << "Object Not defined: " << game_obj->bp_name() << endl);
  return NULL;

}

void GameObjWrapper::CleanUp() {
  dead = true;

  // comment: i do not like ffdata here
  if (ffData)
    ffData->CleanUp();
}

