//================================================================
// GeneralAI.H
//================================================================
//TODO:
// Enemy unit clustering
// Player unit re-grouping (when?)
// Strategic Decisions:
// -Mission Types:
//  -AttackCC
//   -Set attacking CC as the primary goal;
//   -Will attack enemy tanks on the way, but won't pursuit
//  -Intercept
//   -Set attacking tanks as the primary goal;
//   -Will go towards smaller enemy cluster, will pursuit;
//   -Formation should be considered
// Stuck enemy detection 
//================================================================

#ifndef GENERALAI_H
#define GENERALAI_H

#include "GlobalDataBase.H"
#include "Clustering.H"
#include "SquadAI.H"

namespace{
  const int MAX_SQUAD_NUMBER = 10;
}

class GeneralAI {
  public:
    GeneralAI();
    ~GeneralAI();
    void Init(); //Initialize squads at the beginning of the game at once
    void Update();
    void Act();
    void CheckCC();
    struct EngagingStatus { //TODO: Haven't been used in engagingMap
      bool engaged;
      int intensity;
    };
    //inline AIMode GetAIMode() const { return aiMode; }
    //vector<SquadAI*>::iterator GetSquads() { return squadAI.begin(); }
    //vector<SquadAI*>::iterator GetSquadsEnd() { return squadAI.end(); }
    //inline sint4 GetSquadCount() { return squadCount; }

    // general helper function
    static int ScanEnemy(const WorldCoor& world_coor, const int& sqr_range);

  private:
    //void ReGrouping(std::vector<GameObjWrapper*> squad1, std::vector<GameObjWrapper*> squad2);  // For player tanks

    bool SquadMerge();
    int engagingMap[MAX_SQUAD_NUMBER * MAX_SQUAD_NUMBER];
    MapCoor clusterTabooLeftTop[MAX_CLUSTER_COUNT];
    MapCoor clusterTabooRightBottom[MAX_CLUSTER_COUNT];
    int tabooCount;
    //void BuildSandModel(vector< vector<int> >& player_sand, const int* ps_index, vector< vector<int> >& enemy_sand, const int* es_index);

    int CalcRescueTime(PlayerCC*, SquadAI*, const int&);
    int CalcPoint(SquadAI* squad, const WorldCoor& dest);
    vector<SquadAI*> squadAI; 

    AIMode aiMode;

    inline void DefensiveAI();
    inline void DefaultAI();
    inline void StandyAI();
};

#endif
