#include "MapBox.H"
#include <string>
#include <cstring>

/* 
   Copyright 2007 Man Hon Chan, Zhangbo Liu, Simon Suyadi
   This code is Licensed under GPL.
 */

namespace {
  bool TileWalkable(const GameTile& tile) {
    sint4 hNW, hNE, hSE, hSW;
    Tile::Split split;
    tile.get_topo(hNW, hNE, hSE, hSW, split);
    return (split == Tile::NO_SPLIT) && !(hNW > 0 || hNE > 0 || hSE > 0 || hSW > 0);
  }
}

char MapBox::taboo[MAP_NUM_ROW][MAP_NUM_COL];
char MapBox::inaccessible[MAP_NUM_ROW][MAP_NUM_COL];

const int MapBox::dummy = StaticInit();

int MapBox::StaticInit() {
  return 0;
}

void MapBox::Init(const Map<GameTile>& m) {
  memset(taboo, 0, sizeof(taboo));
  // Fill in the entries
  for (int r = 0; r < MAP_NUM_ROW; ++r)
    for (int c = 0; c < MAP_NUM_COL; ++c) {
      const GameTile &t = m(c, r); // Convert x,y into r,c.....
      bool accessible = TileWalkable(t);
      inaccessible[r][c] = accessible?0:1;
    }
}

