#ifndef PLAYER_CC_H
#define PLAYER_CC_H

#include "GameObjWrapper.H"

class PlayerCC: public GameObjWrapper {
  public:
    PlayerCC():GameObjWrapper() {}

    bool Update();
    inline sint4 GetHP() const { return hp; }

    void Init(GameObj* game_obj);
    void RefreshStat();

    inline const sint4& GetHarassSet() const { return harassSet; }
    inline const sint4& GetHarassTankCount() const { return harassTankCount; }
    inline const sint4& GetHarassTankTotalHP() const { return harassTankTotalHP; }

    inline const WorldCoor& GetLeftTop() const { return leftTop; }
    inline const WorldCoor& GetRightBottom() const { return rightBottom; }
    inline const MapCoor GetTargetPoint(const WorldCoor& from) const {
      MapCoor ret(mapCoor);
      //if (from.x > worldCoor.x) ret.c -= 2;
      //else if (from.x < worldCoor.x) ret.c += 2;
      //if (from.y > worldCoor.y) ret.r -= 2;
      //else if (from.y < worldCoor.y) ret.r += 2;
      if (from.x > worldCoor.x) ret.c -= 2;
      else ret.c +=2;
      return ret;
    }

    inline void AddRescuer() { rescueSquadCount++; }
    inline void RemoveRescuer() { rescueSquadCount--; }
    inline int GetRescuer() const { return rescueSquadCount; }

  private:
    sint4 rescueSquadCount;
    sint4 hp;
    sint4 harassSet;
    sint4 harassTankCount;
    sint4 harassTankTotalHP;
    WorldCoor leftTop, rightBottom;
};

#endif
