#include "Target.H"

#include "PlayerCC.H"
#include "EnemyObj.H"
#include "SquadAI.H"
#include "Clustering.H"
#include "GeneralAI.H"

/* 
   Copyright 2007 Man Hon Chan, Zhangbo Liu, Simon Suyadi
   This code is Licensed under GPL.
 */

#define FOR_RANGE(it, begin, end) for ( typeof(begin) it = (begin),\
    _end_of_loop_ ## it = (end); it != _end_of_loop_ ## it ; ++it)

namespace {
  const int CLUSTER_SCAN_RANGE = 112 * 3 / 2;
  const int TARGET_SCAN_SQR_RANGE = (112) * (112);
}

Target_PlayerCC::Target_PlayerCC(PlayerCC* c) : cc(c) {
  type = target_playercc;
  cc->AddRescuer();
}

Target_PlayerCC::~Target_PlayerCC() {
  cc->RemoveRescuer();
}

void Target_PlayerCC::Update(const SquadAI* sq) {
  if(cc->IsDead()) isvalid = false;
  else {
    const int& harass_tankcount = cc->GetHarassTankCount();
    isvalid = (harass_tankcount > 0)
      && (harass_tankcount < sq->NumOfTanks())
      && MapBox::Walkable(cc->GetMapCoor());
  }
  if(isvalid) {
    waypoint = cc->GetMapCoor();
  }
}

void Target_Area::Update(const SquadAI* sq) {
  harassTankCount = GeneralAI::ScanEnemy(worldCoor, TARGET_SCAN_SQR_RANGE);
  /*
  harassSet = 0;
  harassTankTotalHP = 0;
  harassTankCount = 0;
  for (EnemyTank* const* i = GlobalDataBase::GetEnemyTanks(),
      * const* ei = GlobalDataBase::GetEnemyTanksEnd(); i != ei; ++i)
    if ( worldCoor.SqrDist( (*i)->GetWorldCoor() ) < TARGET_SCAN_SQR_RANGE ) {
      harassSet |= (1 << (*i)->GetCluster()->GetID() );
      harassTankTotalHP += (*i)->GetHP();
    }
  int bk = harassSet;
  while(bk) {
    int last_bit = bk ^ (bk & (bk - 1));
    bk ^= last_bit;
    last_bit = __builtin_ctz(last_bit);
    harassTankCount += Clustering::GetClusters()[last_bit]->GetSize();
  }
  */
  if(sq->NumOfTanks() < harassTankCount || harassTankCount == 0) {
    isvalid = false;
  }
  //FOR_RANGE(cl, Clustering::GetClusters(), Clustering::GetClustersEnd()) {
  //}
}

void Target_PlayerCC::PrintTarget(ostream& out) {
  out << "Target type=PlayerCC Loc=" << waypoint.r << "," << waypoint.c << endl;
}

void Target_Area::PrintTarget(ostream& out) {
  out << "Target type=Area Loc=" << waypoint.r << "," << waypoint.c;
  out << " harassTankCount=" << harassTankCount << endl;
}

/*
   void Target_Squad::Update(const SquadAI* sq) {
   int i = 0;
// if squad splits.
// maybe join the bigger squad
// or join the nearest tank
int dist = 99999, closest = -1;
for(int i = 0; i < tanks.size(); i++) {
if(tanks[i]->IsDead()) continue;
int d = dist(from, tanks[i]->GetWorldCoor());
if(d < dist) {
d = dist; closest = i;
}
//waypoint = tanks[i]->GetSquad()->GetCenterOfMass();
}
if(dist == 999999) {
isvalid = false;
} else {
waypoint = tanks[closest]->GetWorldCoor();
}
}
 */

/*
void Target_EnemyCC::Update(const SquadAI* sq) {
  //LOG(ferr << "Squad " << i << ": Attack" << endl);
  sint4 min_dist = 99999999;
  sint4 dist = 0;
  sint4 closest = -1;
  EnemyCC** enemyCCs = GlobalDataBase::GetEnemyCCs();
  for (int j = 0; j < GlobalDataBase::GetEnemyCCCount(); j++) {
    //if ( !MapBox::Walkable(enemyCCs[i]->GetMapCoor()) ) continue;
    dist = enemyCCs[j]->GetWorldCoor().SqrDist(from)+1;
    //Assume squadTanks[0] is not NULL
    if (dist < min_dist) {
      min_dist = dist;
      closest = j;
    }
  }
  if((isvalid = (closest != -1)))
    waypoint = enemyCCs[closest]->GetMapCoor();
  else
    waypoint = from.GetMapCoor();
}

void Target_EnemyCC::PrintTarget(ostream& out) {
  out << "Target type=EnemyCC Loc=" << waypoint.r << "," << waypoint.c << endl;
}

*/


