#include "XTerrainEngine.H"
#include <iostream>
#include <cstring>
using namespace std;

/* 
   Copyright 2007 Man Hon Chan, Zhangbo Liu, Simon Suyadi
   This code is Licensed under GPL.
 */

//*************************************

const int XTerrainEngine::dummyInit = StaticInit();
int XTerrainEngine::mdata[MAP_SIZE+2][MAP_SIZE+2];

const int XTerrainEngine::StaticInit() {
  //memset(mdata, T_BLOCK, sizeof(mdata));
  for(int i = 0; i < 64 + 2; i++)
  for(int j = 0; j < 64 + 2; j++)
    mdata[i][j] = T_BLOCK;
  return 0;
}

int XTConvert(const GameTile& tile) {
  const real4 HEIGHT_THRESHOLD = 1e-4;
  sint4 hNW, hNE, hSE, hSW;
  Tile::Split split;
  tile.get_topo(hNW, hNE, hSE, hSW, split);
  switch(split) {
    case Tile::NO_SPLIT:
      if (tile.height_at(0.5, 0.5) < HEIGHT_THRESHOLD) return T_EMPTY;
      else return T_BLOCK;
    case Tile::TB_SPLIT:
      if (hNE == 0 && tile.height_at(0.75, 0.25) < HEIGHT_THRESHOLD) return T_BL;
      else if (hSW == 0 && tile.height_at(0.25, 0.75) < HEIGHT_THRESHOLD) return T_TR;
      else return T_BLOCK;
    case Tile::BT_SPLIT:
      if (hNW == 0 && tile.height_at(0.25, 0.25) < HEIGHT_THRESHOLD) return T_BR;
      else if (hSE == 0 && tile.height_at(0.75, 0.75) < HEIGHT_THRESHOLD) return T_TL;
      else return T_BLOCK;
  }
  return T_BLOCK;
}
