//=======================================================
//TODO:
// 1. The value of k is given arbitrarily, which will 
//  not work when the number of enemy's tank become small
//=======================================================
#ifndef CLUSTERING_H
#define CLUSTERING_H

#include "Primitive.H"
//#include "Random.H"
#include "GameObjWrapper.H"
#include "GlobalDataBase.H"
#include <vector>

using namespace std;

class Clustering {
  public:
    Clustering() {}

    void KMedoids(EnemyTank** enemy, const int& n, std::vector<EnemyTank*>& medoids_obj, const int& k, vector<int>& medoids_size);

    void InitAssignClosest(PlayerTank** unit, const int& n, PlayerCC** medoids, const int& k);

    void Evolve(EnemyTank** enemy, const int& n, EnemyTank** medoids, const int&k);

    sint4 AssignAndTestClosest(EnemyTank** enemy, const int& n, EnemyTank** medoids, const int& k, const sint4& threshold);

    void Merge(EnemyTank** enemy, vector<EnemyTank*>& medoids_obj, vector<int>& medoids_size, const int& index1, const int& index2);
  private:

    sint4 Cost(EnemyTank** enemy, const int& n, EnemyTank* medoid);
    void Sorting(EnemyTank* enemy[], const int& k);
};
#endif
