#ifndef FF_PRIMITIVE_H
#define FF_PRIMITIVE_H

#include "Primitive.H"
#include <complex>

namespace {

  using std::max;
  using std::min;
  typedef std::complex<double> Force;

  // Return left - right in terms of force
  inline Force Diff(const WorldCoor& left, const WorldCoor& right) {
    return Force(left.x - right.x, left.y - right.y);
  }

  inline Force NormalizedDiff(const WorldCoor& left, const WorldCoor& right) {
    Force ret(left.x - right.x, left.y - right.y);
    return ret / abs(ret);
  }

  inline double dot(const Force& a, const Force& b) {
    return a.real() * b.real() + a.imag() * b.imag();
  }

  inline double dot(const MapDirection& a, const Force& b) {
    return a.dc * b.real() + a.dr * b.imag();
  }
}

#endif
