#ifndef PLAYER_TANK_H
#define PLAYER_TANK_H

#include "GameObjWrapper.H"
#include "EnemyObj.H"

class PlayerTank: public GameObjWrapper {
  public:
    PlayerTank();
    void Init(GameObj* game_obj);

    bool Update();
    inline const sint4& GetHP() const { return hp; }

    sint4 GetCooldown() const;

    void SetDest(const MapCoor& coor);
    inline MapCoor GetDest() { return dest; }

    inline void SetWayPoint(const WorldCoor& way_point) { wayPoint = way_point; }
    inline void SetSpeed(sint4 speed_) { speed = speed_; }

    inline void SetTarget(EnemyObj* enemy_obj) { target = enemy_obj; }
    inline EnemyObj* GetTarget() const { return target; }

    void Act(); // Do what you should do now

    EnemyObj* WeakestInRange(sint4 range) const; 
    //inline bool IsInBattle() const { return inBattle; }

  protected:
    GlobalDataBase* globalDataBase;
    sint4 hp; 
    sint4 cooldown;
    MapCoor dest;
    EnemyObj* target;
    WorldCoor wayPoint;
    sint4 speed;
    sint4 nextFireTime;
    //bool inBattle;
  private:
    static Vector<sint4> attackArgs;
    static Vector<sint4> moveArgs;

};

#endif
