#include "FFData.H"
#include "FFEngine.H"
#include "XTerrainEngine.H"

void FFEnemyData::CleanUp() {
  FFEngine::ClearEnemyData(this);
}

void FFNeutralData::CleanUp() {
  FFEngine::ClearNeutralData(this);
}

void FFPlayerData::CleanUp() {
  FFEngine::ClearPlayerData(this);
}

void FFStaticData::Init() {
  leftTop = MapBox::GetMapCoor(
      ((PlayerCC*)gameObjWrapper)->GetLeftTop() );
  rightBottom = MapBox::GetMapCoor(
      ((PlayerCC*)gameObjWrapper)->GetRightBottom() );
  MapBox::AddTaboo(leftTop, rightBottom);

  XTerrainEngine::Set(leftTop.r, leftTop.c, C_BR);
  XTerrainEngine::Set(leftTop.r, rightBottom.c, C_BL);
  XTerrainEngine::Set(rightBottom.r, leftTop.c, C_TR);
  XTerrainEngine::Set(rightBottom.r, rightBottom.c, C_TL);
  for (int r = leftTop.r+1; r < rightBottom.r; ++r) {
    XTerrainEngine::Set(r, leftTop.c, C_R);
    XTerrainEngine::Set(r, rightBottom.c, C_L);
  }
  for (int c = leftTop.c+1; c < rightBottom.c; ++c) {
    XTerrainEngine::Set(leftTop.r, c, C_B);
    XTerrainEngine::Set(rightBottom.r, c, C_T);
  }
}

void FFStaticData::CleanUp() {
  MapBox::RemoveTaboo(leftTop, rightBottom);

  for (int r = leftTop.r; r <= rightBottom.r; ++r)
    for (int c = leftTop.c; c <= rightBottom.c; ++c)
      XTerrainEngine::Set(r, c, T_EMPTY);
}
