//=================================================================
// SquadAI.H
// Responsible for making tactic decisions for one squad of tank
//=================================================================
// TODO:
// Personality of SquadAI, to be or not to be
// Prevent overkilling
//=================================================================
#ifndef SQUADAI_H
#define SQUADAI_H

#include "PlayerTank.H"
#include "EnemyObj.H"
//#include "Formations.H"
namespace {
  enum MissionType {Attack, Intercept, Retreat};
}
using namespace std;

class SquadAI {

  public:
      SquadAI();
      
      void AddTank(PlayerTank* tank);

      void Act();

      bool IsAlive() { return squadTanks.size();}

      inline sint4 NumOfTanks() { return squadTanks.size(); }

      inline MapCoor GetDest() { return ClosestEnemyCC()->GetMapCoor();}  

      EnemyCC* ClosestEnemyCC();

      inline sint4 GetID() { return ID; }
      inline void SetID(const sint4& id) { ID = id; } 

      inline vector<PlayerTank*> GetTanks() { return squadTanks; }

      inline MissionType GetMissionType() { return missionType; }
      inline void SetMissionType(const MissionType& type) { missionType = type; }

      void EngagingEnemyCluster(int* engaging_map, const int& max_squad_number);

      //inline bool IsProcessed() { return isProcessed; }
      //void Doprocess();
      inline bool IsInBattle() { return inBattle; }

  protected:

  private:
      std::vector<PlayerTank*> squadTanks; 
      sint4 ID;
      
      MissionType missionType;
      
      bool inBattle;
      //bool isProcessed;
      


      //double rotation;
      
      //WorldCoor goal;
      

      //WorldCoor GetClosestEnemyCC(GlobalDataBase* gdb);

      //void SetGoal(GlobalDataBase* gdb);  // Not in use

      //WorldCoor RotateFormation(WorldCoor p, double angle);
      //void    FormFormation();


};
#endif
