#ifndef ENEMY_OBJ_H
#define ENEMY_OBJ_H

#include "ScriptObj.H"
#include "GameObjWrapper.H"

class EnemyObj: public GameObjWrapper {
  public:
    bool Update();

    inline const sint4& GetHP() const { return hp; }

    inline const ObjId& GetID() const { return id; }

    int enemyIndex; // Used by GlobalDataBase to keep track of ALL enemies

  protected:
    sint4 hp;
    ObjId id;
    EnemyObj() {}
    void Init(GameObj* game_obj);

};

class EnemyTank: public EnemyObj { // Nothing too special about this
  public:
    EnemyTank():EnemyObj() {}
    void Init(GameObj* game_obj);
  protected:
  private:
    //sint4 clusterID;   // For clustering
};

class EnemyCC: public EnemyObj {
  public:
    EnemyCC():EnemyObj() {}
    void Init(GameObj* game_obj);

    bool Update();
    inline WorldCoor GetLeftTop() { return leftTop; }
    inline WorldCoor GetRightBottom() { return rightBottom; }
  protected:
  private:
    WorldCoor leftTop, rightBottom;

};
#endif
