//================================================================
// GeneralAI.H
//================================================================
//TODO:
// Enemy unit clustering
// Player unit re-grouping (when?)
// Strategic Decisions:
// -Mission Types:
//  -AttackCC
//   -Set attacking CC as the primary goal;
//   -Will attack enemy tanks on the way, but won't pursuit
//  -Intercept
//   -Set attacking tanks as the primary goal;
//   -Will go towards smaller enemy cluster, will pursuit;
//   -Formation should be considered
// Stuck enemy detection 
//================================================================

#ifndef GENERALAI_H
#define GENERALAI_H

#include "GlobalDataBase.H"
#include "Clustering.H"
#include "SquadAI.H"

namespace{
  const int MAX_SQUAD_NUMBER = 10;
}

class GeneralAI {

  public:
    
    GeneralAI();
    
    ~GeneralAI();
    void Init(); //Initialize squads at the beginning of the game at once

    void Update();
    
    void Act();

    struct EngagingStatus { //TODO: Haven't been used in engagingMap
      bool engaged;
      int intensity;
    };
    //inline Clustering* GetClustering() { return clustering; }

    //inline sint4 GetSquadCount() { return squadCount; }
  private:

    //void ReGrouping(std::vector<GameObjWrapper*> squad1, std::vector<GameObjWrapper*> squad2);  // For player tanks
    Clustering* clustering;
    vector<EnemyTank*> medoidsObj;
    vector<int> medoidsSize;

    vector<SquadAI*> squadAI; 

    int engagingMap[MAX_SQUAD_NUMBER * MAX_SQUAD_NUMBER];

    MapCoor medoidsTabooLeftTop[MAX_SQUAD_NUMBER];
    MapCoor medoidsTabooRightBottom[MAX_SQUAD_NUMBER];
    int tabooCount;

    //void BuildSandModel(vector< vector<int> >& player_sand, const int* ps_index, vector< vector<int> >& enemy_sand, const int* es_index);

};

#endif
