#ifndef X_TERRAIN_ENGINE_H
#define X_TERRAIN_ENGINE_H

#include "Tile.H"
#include "Primitive.H"


namespace {
  enum XTerrain { T_EMPTY = 0, T_BLOCK, T_TL, T_TR, T_BL, T_BR, C_T, C_B, C_L, C_R, C_TL, C_TR, C_BL, C_BR };
  const int MAP_SIZE = 64;
  const int T_COUNT = 14;
}

int XTConvert(const GameTile& tile);

class XTerrainEngine {
  public:
    static inline void Add(const int& r, const int& c, const GameTile& tile) { mdata[r + 1][c + 1] = XTConvert(tile); }
    static inline int Get(const int& r, const int& c) { return mdata[r + 1][c + 1]; }
  private:
    static const int dummyInit;
    static const int StaticInit();
    static int mdata[MAP_SIZE + 2][MAP_SIZE + 2];
};

#endif
