#ifndef Game4EventHandler_H
#define Game4EventHandler_H

// $Id: Game4EventHandler.H,v 1.2 2007/03/15 10:37:47 orts_furtak Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "EventHandler.H"
#include "Random.H"

#include "GlobalDataBase.H"
#include "GeneralAI.H"

class GameStateModule;
class FFEngine;

// This class gives the event handler access to all game and gfx data

struct Game4AIState {

  GameStateModule *gsm;
  bool just_drew;  // just drew a gfx frame
  bool quit;       // true => quit game
  bool error;      // true <=> error occurred
  
  Game4AIState(GameStateModule *gsm_):
    gsm(gsm_) {
    just_drew = quit = error = false;
  }

};


// This class handles server events
// In particular it generates game object actions

class Game4EventHandler : public EventHandler {

public:
  
  Game4AIState &state;

  Game4EventHandler(Game4AIState &state_, sint4 seed) : state(state_), postInitialized(false), clusteringTime(0), generalAITime(0) {
    random.srand(seed);
  }

  bool handle_event(const Event &e);

private:

  GeneralAI* generalAI;
  
  bool postInitialized;
  GlobalDataBase* globalDataBase;  
  FFEngine* ffEngine;

  void ComputeActions();
  Random random; // local RNG
  
  void PostInitialize();

  sint4 clusteringTime;
  sint4 generalAITime;
  
};

#endif
