//=================================================================
// SquadAI.H
// Responsible for making tactic decisions for one squad of marine
//=================================================================
// TODO:
// Personality of SquadAI, to be or not to be
// Prevent overkilling
//=================================================================
#ifndef SQUADAI_H
#define SQUADAI_H

#include "PlayerMarine.H"
#include "EnemyMarine.H"
//#include "Formations.H"
#include "GlobalDataBase.H"
namespace {
  enum MissionType {Attack, Intercept, Retreat};
}
using namespace std;

class SquadAI {

  public:
      SquadAI(GlobalDataBase* global_data_base);
      
      void AddMarine(PlayerMarine* marine);

      void Act();

      bool IsAlive();
      //bool IsAlive() { return !squadMarines.empty();}

      inline sint4 NumOfMarines() const { return squadMarines.size(); }

      //inline MapCoor GetDest() { return ClosestEnemyCC()->GetMapCoor();}  

      inline sint4 GetID() const { return ID; }
      inline void SetID(const sint4& id) { ID = id; } 

      inline vector<PlayerMarine*> GetMarines() { return squadMarines; }

      inline MissionType GetMissionType() const { return missionType; }
      inline void SetMissionType(const MissionType& type) { missionType = type; }

      void EngagingEnemyCluster(int* engaging_map);

      //inline bool IsProcessed() { return isProcessed; }
      //void Doprocess();
      inline bool IsInBattle() const { return inBattle; }
      void CheckBattleStatus();

      inline void SetDest(const WorldCoor& dest) { squadDest = dest; }
      inline WorldCoor GetDest() { return squadDest; }

      void DoAssemble();
      inline void AssemblingOn() { isAssembled = false; }
      inline void AssemblingFinished() { isAssembled = true; }
      inline bool IsAssembled() { return isAssembled; }

  protected:
      GlobalDataBase* globalDataBase;

  private:
      std::vector<PlayerMarine*> squadMarines; 
      sint4 ID;
      
      MissionType missionType;
      
      bool inBattle;

      WorldCoor squadDest;
      //bool isProcessed;
      bool isAssembled;

};
#endif
