#ifndef FF_DATA_H
#define FF_DATA_H

#include "Primitive.H"
#include "FFPrimitive.H"

class FFEngine;
class GameObjWrapper;
class FFPlayerData;

// Provide an entry point for Pathfinding engine to tag auxiliary information to GameObjWrapper
class FFData {
  public:
    void Update();
    virtual void AddForce(const FFPlayerData* const &target,
        Force& player_force, Force& neutral_force) = 0;
    virtual ~FFData();
  protected:
    FFEngine* ffEngine; // The FFEngine attached to this
    GameObjWrapper* gameObjWrapper;
    WorldCoor worldCoor;
    MapCoor mapCoor;

    FFData(FFEngine* ff_engine, GameObjWrapper* game_obj_wrapper);
};

class FFNeutralData:public FFData {
  public:
    FFNeutralData(FFEngine* ff_engine, GameObjWrapper* game_obj_wrapper);
    virtual void AddForce(const FFPlayerData* const &target,
        Force& player_force, Force& neutral_force);
};

class FFPlayerData:public FFData {
  public:
    FFPlayerData(FFEngine* ff_engine, GameObjWrapper* game_obj_wrapper);
    virtual void AddForce(const FFPlayerData* const &target,
        Force& player_force, Force& neutral_force);
  private:
    friend class FFNeutralData;
    friend class FFEngine;
};

#endif
