#ifndef GAME_OBJ_WRAPPER_H
#define GAME_OBJ_WRAPPER_H

#include "Primitive.H"
#include "GameObj.H"
#include "Game.H"

class GlobalDataBase;
class FFData;

class GameObjWrapper {
  public:
    static GameObjWrapper* GetWrapper(GameObj* game_obj, GlobalDataBase *global_data_base);

    // update should be called per frame
    // It returns if the object is still valid.
    // If not, the corresponding destructor will be called.
    virtual bool Update();
    virtual void CleanUp();

    virtual ~GameObjWrapper(); // This is doing nothing right now, but we must allow it to have a destructor

    inline const WorldCoor& GetWorldCoor() const { return worldCoor; }
    inline bool IsDead() const { return dead; }
    inline GameObj* GetGameObj() const { return gameObj; }

    // For GlobalDatabase to maintain the arrays
    int arrayIndex;

    // For Force field pathing
    FFData* ffData;

  protected:
    GameObjWrapper(GameObj* game_obj, GlobalDataBase* global_data_base);

    GameObj* gameObj;
    //MapBox* mapBox;
    WorldCoor worldCoor;
    //MapCoor mapCoor;
    bool dead;
};

#endif
