#ifndef PLAYER_MARINE_H
#define PLAYER_MARINE_H

#include "GameObjWrapper.H"
#include "EnemyMarine.H"

class SquadAI;

class PlayerMarine: public GameObjWrapper {
  public:
    bool Update();
    inline sint4 GetHP() const { return hp; }
    sint4 GetCooldown() const;

    inline const WorldCoor GetDest() const { return dest; }
    inline void SetDest(const WorldCoor& coor) { dest = coor; }
    inline void SetWayPoint(const WorldCoor& way_point) { wayPoint = way_point; }
    inline void SetSpeed(sint4 speed_) { speed = speed_; }
    inline void SetTarget(EnemyMarine* enemy_obj) { target = enemy_obj; }
    inline EnemyMarine* GetTarget() { return target; }

    void Act(); // Do what you should do now

    EnemyMarine* WeakestInRange(sint4 range); 
    inline bool IsInBattle() { return inBattle; }
    inline bool IsInitAchieved() { return initAchieved; }
    inline void AchieveInit() { initAchieved = true; }

    inline void SetSquad(SquadAI* squad_) { squad = squad_; }
    inline SquadAI* GetSquad() { return squad; }

  protected:
    GlobalDataBase* globalDataBase;
    sint4 hp; 
    sint4 cooldown;
    WorldCoor dest;
    PlayerMarine(GameObj* game_obj, GlobalDataBase* global_data_base);
    EnemyMarine* target;
    WorldCoor wayPoint;
    sint4 speed;
    sint4 nextFireTime;
    bool inBattle;
    bool initAchieved;
    SquadAI* squad;

  private:
    static Vector<sint4> attackArgs;
    static Vector<sint4> moveArgs;

    friend GameObjWrapper* GameObjWrapper::GetWrapper(GameObj* game_obj, GlobalDataBase *global_data_base);
};

#endif
