#ifndef PRIMITIVE_H
#define PRIMITIVE_H

#include <iostream>
#include "Game.H"

struct MapCoor {
  sint4 r, c;
  MapCoor(sint4 rr = -1, sint4 cc = -1):r(rr), c(cc) {}

  bool operator== (const MapCoor& other) const;
  bool operator!= (const MapCoor& other) const;
  bool operator< (const MapCoor& other) const;
};

struct WorldCoor {
  sint4 x, y;
  WorldCoor(sint4 xx = -1, sint4 yy = -1): x(xx), y(yy) {}
  bool operator== (const WorldCoor& other) const;
  bool operator!= (const WorldCoor& other) const;
  bool operator< (const WorldCoor& other) const;
  sint4 sqr_dist(const WorldCoor& other) const;
  double dist(const WorldCoor& other) const;

};

struct MapDirection {
  sint4 dr, dc;
  MapDirection(sint4 dr_ = 0, sint4 dc_ = 0):dr(dr_), dc(dc_) {}

  bool operator==(const MapDirection& other) const;
  bool operator!=(const MapDirection& other) const;
  bool operator<(const MapDirection& other) const;
};

MapCoor operator+(const MapCoor& coor, const MapDirection& dir);

const int NUM_OTHOGONAL_DIR = 4;
const MapDirection ORTHOGONAL_DIR[] = {
  MapDirection(-1, 0), MapDirection(0, -1), MapDirection(0, 1), MapDirection(1, 0) };
const int NUM_DIAGONAL_DIR = 4;
const MapDirection DIAGONAL_DIR[] = {
  MapDirection(-1, -1), MapDirection(-1, 1), MapDirection(1, -1), MapDirection(1, 1) };

std::ostream& operator<<(std::ostream& os, const MapCoor& coor);
std::ostream& operator<<(std::ostream& os, const WorldCoor& coor);
std::ostream& operator<<(std::ostream& os, const MapDirection& dir);
#endif
