#ifndef MapEvalHandler_H
#define MapEvalHandler_H

// $Id: MapEvalHandler.h,v 1.14 2006/06/07 08:24:26 orts_frano Exp $

// This is an ORTS file (c) Frano Sailer, licensed under the GPL

#include "GfxModule.H"
#include "HeuristicMapWidget.h"
#include"ClientState.H"

// this structure holds all the attributes of immobile game objects
struct ImmobileObject{
  uint4 x, y;
  sint4* attributes;
};


class MapEvalHandler : public EventHandler{
public:
/*
  MapEvalHandler(GfxModule* gfxm, GameStateModule *gsm,
		 HeuristicMapWidget* widget,
		 uint4 staticRange, real8 rangeModifier, real8 decay);
*/
  MapEvalHandler(ClientState &c,
		 HeuristicMapWidget* widget,
		 uint4 staticRange, real8 rangeModifier, real8 decay);
  ~MapEvalHandler();

  bool handle_event(const Event&);

  void updateValuesInRange(sint4 xIndex, sint4 yindex, uint4 attribute,
			   uint4 type, sint4 value, uint4 range, bool vanished, bool immobile);
  void updateFogOfWarMap(sint4 xIndex, sint4 yIndex,uint4 range);
  void resetAgeMap(sint4 xIndex,sint4 yIndex,uint4 range);

  void processNewObject(GameObj* gob);
  void processDeadObject(GameObj* gob);
  void processVanishedObject(GameObj* gob);
  void processChangedObject(GameObj* gob);

  sint4 getImmobileObjectIndex(const Vector<ImmobileObject>&, uint4 x, uint4 y);
  void setImmobileObjectInfluenceRange(uint4 range);
  void setRangeModifier(real8 rangeModifier);
  void setDecayRate(real8 decayRate);
  void clearImmobileObjects();

protected:

private:
  ClientState &state;

  //GfxModule* gfxm;
  //GameStateModule *gsm;
  HeuristicMapWidget* widget;

  uint4 immobileObjectInfluenceRange;
  real8 rangeModifier;
  real8 decayRate;

  uint4 playerID;
  uint4 numPlayers;

  bool firstTime;

  Vector<ImmobileObject>** immobileObjects;

};

#endif
