using namespace Protocol;

void AnonymizingDialog::init(){
    
    setAliasEdited( false );
    setPasswordEdited( false );
}

void AnonymizingDialog::setup( Handler *ahandler, int iid, string user, bool anony_id, bool passprotected ){
    
    handler = ahandler;
    setAnonyid( anony_id );
    setPassProtected( passprotected );
    m_iid = iid;
    m_user = user;
 
    ///////////////////////////
    if( anony_id )   cout << "Anonymizing setup -> anony_id TRUE" << endl;
    if( passprotected ) cout << "Anonmizing setup -> passprotected TRUE "<< endl;
    //////////////////////////
    
    if( !getAnonyid() ){
	aliastextLabel->setEnabled( false );
	aliaslineEdit->setEnabled( false );
    }else{
	aliastextLabel->setEnabled( true );
	aliaslineEdit->setEnabled( true );
    }   
    
    if( !getPassProtected() ){
	passwordtextLabel->setEnabled( false );
	passwordlineEdit->setEnabled( false );
    }else{
	passwordtextLabel->setEnabled( true );
	passwordlineEdit->setEnabled( true );
    }
    
    
}

void AnonymizingDialog::processAnonyInfo()
{	
    if( getAnonyid() ) { /* require anonymizing id */
	noticetextEdit->append("This game allows you to change your user name while in the game.  Please choose a new temporary user name. If you wish to use your current user name leave the 'Alias' field blank.");
	string alias = aliaslineEdit->text();
	if( alias.length() != 0 ){
	    setAlias( alias ); 
	    setAliasEdited( true );
	}else{
	    alias = "null";
	    setAlias( alias );
	} 
      
    }
   
    if( getPassProtected() ) { /* require password */
	string password = passwordlineEdit->text();
	noticetextEdit->append("\nThis game requires a password. Please enter the password.");
	if( password.length() != 0 ){
	    setPassword( password );
	    setPasswordEdited( true );
		
	}
    }	
    
    string alias;
    string pass;

    if( getAnonyid() && getAliasEdited() ) 
      alias = getAlias();
    else alias = "null";

    if( getPassProtected() && getPasswordEdited() )
      pass  = getPassword();
    else pass  = "null";

    // request join
    //////////////////////////
    cout << "TEST JOIN: "<< Join::compose(m_iid, getAnonyid(), alias, getPassProtected(), pass) << endl;
    ////////////////////////
    handler->tellService(Join::compose(m_iid, getAnonyid(), alias, getPassProtected(), pass));
    
    m_password = "null"; /* Fixme. Alternative is to destroy() this dialog which would require us to create a new instance everytime */
    this->hide();
    
    
}

void AnonymizingDialog::processCancel()
{
    this->close();
}



// Mutator methods
void AnonymizingDialog::setAnonyid( bool anonyid )
{	
    m_anonyid = anonyid;
}

void AnonymizingDialog::setAlias( string & alias )
{
    m_alias = alias;
}

void AnonymizingDialog::setPassProtected( bool passprotected )
{
    m_passprotected = passprotected;
}

void AnonymizingDialog::setPassword( string & password )
{
    m_password = password;
}

void AnonymizingDialog::setAliasEdited( bool aliasEdited )
{
    m_aliasEdited = aliasEdited;
}

void AnonymizingDialog::setPasswordEdited( bool passwordEdited )
{
    m_passwordEdited = passwordEdited;
}


// Accessor Methods
bool AnonymizingDialog::getAnonyid()
{
    return m_anonyid;
}

string AnonymizingDialog::getAlias()
{
    return m_alias;
}

bool AnonymizingDialog::getPassProtected()
{
    return m_passprotected;
}

string AnonymizingDialog::getPassword()
{
    return m_password;
}

bool AnonymizingDialog::getAliasEdited()
{
    return m_aliasEdited;
}


bool AnonymizingDialog::getPasswordEdited()
{
    return m_passwordEdited;
}
