#ifndef Game1_SimpleTerrainWidget_H
#define Game1_SimpleTerrainWidget_H

// $Id $

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "Global.H"
#include "Game1_SimpleTerrain.H"
#include "Game1_ST_SimpleMap.H"

#ifndef GAME1_SIMPLE_TERRAIN_NO_GFX

#include "CGridBase.H"
#include "DrawOnTerrain.H"
#include "EventHandler.H"

class GfxModule;

//===================================================================

namespace Game1_SimpleTerrain {

  class SimpleTerrainOverlay : public EventHandler {
  private:
    const ST_Terrain *terrain_p;
    DrawOnTerrain dot;
    bool enabled;

    GfxModule *gfxm;

  public:
    SimpleTerrainOverlay(const ST_Terrain &terrain, GfxModule &gfxm);

    bool is_enabled() const { return enabled; }
    void enable() { enabled = true; }
    void disable() { enabled = false; }
    void draw();

    bool handle_event(const Event &e);
  };

  //-----------------------------------------------------------------

  class SimpleTerrainWidget : public CGridBase
  {
  private:

    sint4 wwidth;
    sint4 wheight;

    bool draw_tiles;
    bool draw_air;

    const ST_Terrain *terrain_p;
    SimpleTerrainOverlay *overlay;

  public:

    SimpleTerrainWidget(const ST_Terrain &terrain, GfxModule *gfxm=0);
    ~SimpleTerrainWidget();

    virtual stype event_key_down(stype key, stype mod, stype x, stype y);
    virtual stype draw();
  };

}

//===================================================================

#endif // ifndef GAME1_SIMPLE_TERRAIN_NO_GFX

#endif
