#include "Game.H"
#include "GameStateModule.H"

#include "GobPtrWrapper.H"
//#include "Game1_GlobalState.H"

using namespace std;

const string Worker::miningComponent("pickaxe");
const string Worker::miningAction("mine");
const string Worker::returnResourcesAction("return_resources");

ScalarPoint GobPtrWrapper::getPosition(void) const
{
  return ScalarPoint(*(gob->sod.x), *(gob->sod.y));
}

bool GobPtrWrapper::isMoving(void) const 
{ 
  return (*(gob->sod.speed) > 0) || (*(gob->sod.is_moving) != 0);
}

Scalar GobPtrWrapper::distance_to(const GobPtrWrapper& other) const {
  return FixedPoint::from_real8(Distance::distance(*gob, *other.gob));
}

Scalar GobPtrWrapper::distance_to(Scalar x, Scalar y) const {
  return FixedPoint::from_real8(Distance::distance(*gob, x, y));
}

/**************************************************************************/

void Worker::returnMinerals(const GobPtrWrapper& controlCenter)
{
  PlayerInfo& pi = gsm.get_game().get_cplayer_info();
  Vector<sint4> args(1, pi.get_id(const_cast<GobPtrWrapper&>(controlCenter)));
  gob->set_action(returnResourcesAction, args);

  cout << static_cast<Object*>(gob) << " Return minerals (" << getMinerals() << ")" << endl;
}

void Worker::startMining(const GobPtrWrapper& mineral)
{
  PlayerInfo& pi = gsm.get_game().get_cplayer_info();
  Vector<sint4> args(1, pi.get_id(const_cast<GobPtrWrapper&>(mineral)));
  gob->component(miningComponent)->set_action(miningAction, args);

  cout << static_cast<Object*>(gob) << " Start mining" << endl;
}


sint4 Worker::getMinerals(void) const 
{
  return gob->get_int("minerals");
}

bool Worker::isMining(void) const 
{
  return gob->component(miningComponent)->get_int("active") != 0; 

#if 0
  // The "active" flag by itself appears to be inaccurate sometimes (bug?)
  bool miningNow = gob->component(miningComponent)->get_int("active") != 0;
  if( !miningNow )
    return false;

  // remember current values for the next call
  sint4 lmf = last_mining_frame;
  last_mining_frame = gsm.get_game().get_view_frame();
  sint4 pm = prev_minerals;
  prev_minerals = getMinerals();

  // if was already mining recently, verify that the minerals accumulate
  if( /*lmf != -1 &&*/ last_mining_frame - lmf == 1 )
    return prev_minerals > pm;
  else 
    return true;  
#endif
}
