#ifndef TM_SCORE_H
#define TM_SCORE_H

// $Id: TM_Score.H,v 1.5 2007/05/24 03:17:55 orts_mburo Exp $

// (c) M.Buro, licensed under the GPL2

#include <string>

// compute player score(s) from game result string(s)

// return true iff error in result lines

typedef bool (*score_func_p)(const std::string &res1, const std::string &dummy, float &sc1, float &sc2);

// game 1: one-player game, single game, @return score of player 1 
extern bool score1(const std::string &res1, const std::string &dummy, float &sc1, float &dummy);

// game 2: two-player, pair game, @return combined scores for player 1 (in first game) and player 2
extern bool score2(const std::string &res1, const std::string &res2, float &sc1, float &sc2);

// game 3: two-player, pair game, @return combined scores for player 1 (in first game) and player 2
extern bool score3(const std::string &res1, const std::string &res2, float &sc1, float &sc2);

// game 4: two-player, single game: @return scores of player 1 and 2
extern bool score4(const std::string &res1, const std::string &dummy, float &sc1, float &sc2);

extern void score1_test();
extern void score2_test();
extern void score3_test();
extern void score4_test();

#endif
