// $Id: Net_Message.C,v 1.1 2005/01/04 19:13:17 orts_sami Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Net_Message.H"
using namespace std;


Net_Message::Net_Message(const string &message_) {
  message = message_;
  parse(message);
}

Net_Message::~Net_Message() {
  REM("~Net_Message has been called");
}

/**
 * Deletes the old structure.
 * Parses the given message and puts it in a new structure.
 */
void Net_Message::setMessage(const string &s) {
  arguments.clear();
  message = s;
  parse(message);
}

/** Parses the message and stores the arguments. */

sint4 Net_Message::parse(const string &s)
{
  stringstream ss(s);
  string temp;

  // get the destination
  ss >> temp;
  int i = temp.find(':', 0);

  if(i < 0){
    to = temp;
    ss >> temp;
  }else{
    to = RECEIVER;
  }

  i = temp.find(':', 0);

  if(i >= 0){
    if (i == 0){
      from = GGS;
    }else{
      from.assign(temp,0, i);
    }
  }
  
  while(ss >> temp){
    arguments.push_back(temp);
  }
  
  return arguments.size();
}
