#ifndef ATTRACTOROVERLAY_H
#define ATTRACTOROVERLAY_H

// This is an ORTS file (c) Michael Buro, licensed under the GPL
#include "Global.H"
#include "DrawOnTerrain.H"
#include "EventHandler.H"
#include "ForceFieldPE.H"


class GfxModule;


class AttractorOverlay : public EventHandler {
public:
  AttractorOverlay(const ForceFieldPE &pe, GfxModule &gfxm);

  bool is_enabled() const { return enabled; }
  void enable() { enabled = true; }
  void disable() { enabled = false; }
  void draw();

  bool handle_event(const Event &e);

private:
  const ForceFieldPE *executor_p;
  DrawOnTerrain dot;
  bool enabled;
  GfxModule *gfxm;
};

#endif
