/*
 *  glUtil.h
 *  hog
 *
 *  Created by Nathan Sturtevant on 6/8/05.
 *  Copyright 2005 Nathan Sturtevant, University of Alberta. All rights reserved.
 *
 */

#ifdef OS_MAC
#include <OpenGL/gl.h>
#else
#include <GL/gl.h>
#include <GL/glut.h>
#endif

#ifndef GLUTIL_H
#define GLUTIL_H

//#pragma mark -
//#pragma mark OpenGL structures:
namespace HOG{
/**
 * A generic vector (essentially the same as a point, but offers normalization)
 */
class recVec {
public:
  void normalise();
  GLdouble x,y,z;
};

/**
 * A color; r/g/b are between 0...1
 */
class recColor {
public:
	GLfloat r,g,b;
};

/**
 * A point in 3d space. (OpenGL)
 */
class point3d {
public:
  point3d() {}
  point3d(GLfloat a, GLfloat b, GLfloat c) :x(a), y(b), z(c) {}
  GLfloat x, y, z;
};

}
#endif
