#!/bin/bash
# Run a time test
if [ -z "$1" ]
then
  echo ' '
  echo 'syntax:'
  echo '  time_test.sh <number of games> <player 1 opt>'
  echo ' '
  echo 'example:'
  echo "  time_test.sh 100 '-ai flag' "
  echo ' '
  exit
fi

NUM_GAMES=$1
PLAYER_1_OPTS=$2
PLAYER_2_OPTS='-ai stand'

#echo 'Number of games = ' $NUM_GAMES
#echo 'Player 1:' $PLAYER_1_OPTS
#echo 'Player 2:' $PLAYER_2_OPTS

# Internal Parameters (shouldn't need to be modified)
GAME_LOG=game_log.tmp
RESULTS_LOG=results_log.tmp
WIN_TEXT='wins'
SLEEP_DELAY=2
OPTS='-disp 0'
FRAME_RATE=1000
P1_LOG=p1.log
P2_LOG=p2.log
WIN_TIME_LOG=win_time.tmp

# change to correct directory
cd ..

mv $WIN_TIME_LOG $WIN_TIME_LOG.old
date
echo games: $NUM_GAMES  opts: $PLAYER_1_OPTS

echo '.' 1> $RESULTS_LOG
for ((i=1; i<=NUM_GAMES; i++))
do
  # start server
  sleep $SLEEP_DELAY
  ./ortsmap -out ctf.map -type ctftest
  ./orts -loadmap ctf.map -m server -synchro 1 -f $FRAME_RATE 1> $GAME_LOG &
  
  # start client 1
  sleep $SLEEP_DELAY
  #xterm -e ./ortsai $OPTS $PLAYER_1_OPTS &
  ./ortsai $OPTS $PLAYER_1_OPTS 1> $P1_LOG &
  
  # start client 2
  sleep $SLEEP_DELAY
  #xterm -e ./ortsai $OPTS $PLAYER_2_OPTS
  ./ortsai $OPTS $PLAYER_2_OPTS 1> $P2_LOG

  grep 'Winning time =' $P1_LOG >> $WIN_TIME_LOG
done

# note: player 0 is player 1, 1 is 2...
echo Win Times:
cat $WIN_TIME_LOG
cat $WIN_TIME_LOG > tmp
echo '-1' >> tmp
./average < tmp
echo '---'

mv $RESULTS_LOG $RESULTS_LOG.old
